<?php
// header("Content-Type: text/html; charset=ISO-8859-1");
// header("Content-Type: text/html; charset=utf-8");

/*###########################################################
  - Anzeige der aktuellen Verzeichnisse und Verzeichnisinhalt
  - Generierung einer formatierten Ausgabe
#############################################################*/
class Browser {

    private $rootDir;
//    private $path       = "webmanager/";
    private $path       = "";
    // ist die Anzeige vom Rootdir 3 Ebenen unter dem Ort dieser Lib- PHP- Datei
    // so sind in dieser Variable
    private $actionPath;

    //#######################################################
    // Konstruktor
    public function __construct() {}

    //#######################################################
    // Destruktor
    public function __destruct() {}


    //#######################################################
    // liest das gesamte angeforderte Verzeichnis aus
    // static - wird von Sicherheitsklasse verwendet
    // @ $dirList  - Array welches alle Verzeichnisse enthlt
    // @ $fileList - Array welches alle Dateien enthlt
    static function ArrayReadDir($path,&$dirList,&$fileList)  {

            $arrayNotShow = array();
            Browser::secureNotShow_xml($arrayNotShow);

        if (@is_dir($path)) {
            if ($dh = opendir($path)) {
                // Incrementiervariablen
                                $a = 0;
                $b = 0;

                while (($file = @readdir($dh)) !== false) {
                    $type = @filetype($path.$file);

                    // wenn dieses Verzeichnis kein auszublendentes Vrz. ist
                    // fge es der Verzeichnisliste hinzu
                    if (!in_array($path.$file,$arrayNotShow))  {
                            // Wenn Item ein Verzeichnis ist
                            if ($type == "dir") {
                                    // Gltigkeitsbedingungen fr ein Verzeichnis
                                if ($file != ".") {
                                    if ($file != "..") {
                                            if ($file != "")  {
                                                                                $dirList[$a] = $file;
                                                                                $a++;
                                                                         }
                                    }
                                }
                            }
                            // Wenn Item eine Datei ist
                            elseif ($type == "file")  {
                                if ($file != ".")  {
                                               if ($file != "..")  {
                                                if ($file != "")  {
                                                        $fileList[$b][0] = $file;
                                                        $fileList[$b][1] = @filesize($path.$file);
                                                        $fileList[$b][2] = @substr(@decoct(@fileperms($path.$file)),-3);
                                                        $fileList[$b][3] = @date("d.m.Y, H:i",@filemtime($path.$file));
                                                        $b++;
                                                }
                                        }
                                }
                            }
                    }
                }
                @closedir($dh);
                // Sortierfunktion der Verzeichnis bzw. Dateinamenlisten
                if (count($dirList) > 0) {
                         @sort($dirList);
                }
                if (count($fileList) > 0)  {
                         @sort($fileList);
                }
            }
            else {
                echo "Verzeichnis kann nicht geffnet werden!";
                return false;
            }
        }
        else  {
                die ("Verzeichnis nicht gefunden!");
        }
            return true;
    }

    // Formatiert alle enthaltenen Verzeichnisse und Dateien im aktuellen Ordner
    // @ $path - das angeforderte Verzeichnis
    // @ $dirList  - Array, enthaltene Verzeichnisse
        // @ $fileList - 2D Array, enthaltene Dateien
    public function formatItemList ($path,&$dirList,&$fileList)  {
            $size = 0;
            $this->read_xml();
            $this->actionPath = substr($path,6);

            // zeige den Zurck Button wenn angefordertes V
            if ($this->rootDir != $path)  {
                    $backlink = "";
                    $backlinkArray = explode("/",$path);
                    for ($i=0;$i<count($backlinkArray)-2;$i++)  {
                            $backlink .= $backlinkArray[$i]."/";
                    }
                    echo "<div id='wmItML'><img src='".$this->path."img/back.gif' class='naviLinks' title='zur&uuml;ck' onclick='reguser(\"infodaten\",\"".$backlink."\",\"back\");' /></div>";
                    echo "<div style='clear:both;'></div>";
            }


            // Verzeichnis Ausgabe
              for ($i=0;$i<count($dirList);$i++)  {
                  $output  = "<div id='itemList'>";
                  $output .= "<div id='wmItML'><img src='".$this->path."img/foldericon.gif' class='naviLinks' title='".$dirList[$i]."' onclick='reguser(\"infodaten\",\"".$path.$dirList[$i]."/\",\"\");' /></div>";
                  $output .= "<div id='paddLeft'></div>";
                  $output .= "<div style='float:left;'><a href='' id='normLinks' onclick='reguser(\"infodaten\",\"".$path.$dirList[$i]."/\",\"\");return false;' class='normLinks'>".$dirList[$i]."</a></div>";
                  $output .= "<div id='wmItD'></div>";
                  $output .= "<div id='wmItMR'><img src='".$this->path."img/bin_closed.gif' class='naviLinks' onclick=\"voidDeleteDir('".$path.$dirList[$i]."');\" title='L&ouml;schen -> ".$dirList[$i]."' /></div>";
                  $output .= "<div id='wmItMR'><img src='".$this->path."img/rename.gif' class='naviLinks' title='Umbennen -> ".$dirList[$i]."' onclick=\"reguser('renamefile','".$path.$dirList[$i]."','folder');\" /></div>";
                  $output .= "<div id='wmItD'></div>";
                  $output .= "<div id='wmItMR'><img src='".$this->path."img/compress.gif' class='naviLinks' title='Archivieren -> ".$dirList[$i]."' onclick='createZip(\"".$dirList[$i]."\");' /></div>";
                  $output .= "<div id='wmClear'></div>";
                  $output .= "</div>";
                  echo $output;
              }

              // Datei Ausgabe
              for ($i=0;$i<count($fileList);$i++)  {
                  $output  = "<div id='itemList'>";
                  $output .= "<div id='wmItML'><img src='".$this->path."img/page_edit.gif' onclick=\"reguser('infofile','".$path.$fileList[$i][0]."','');return false;\" class='naviLinks' title='Bearbeiten -> ".$fileList[$i][0]."' /></div>";
                  $output .= "<div id='paddLeft'></div>";
//                  $output .= "<div style='float:left;'><a href='".$this->actionPath.$fileList[$i][0]."' target='_blank' id='normLinks'>".$fileList[$i][0]."</a></div>";
                  $output .= "<div style='float:left;'><a href='".$path.$fileList[$i][0]."' target='_blank' id='normLinks'>".$fileList[$i][0]."</a></div>";
                  $output .= "<div id='wmItD'></div>";
                  $output .= "<div id='wmItMR'><img src='".$this->path."img/bin_closed.gif' onclick=\"voidDeleteFile('".$path.$fileList[$i][0]."');\" class='naviLinks' title='L&ouml;schen -> ".$fileList[$i][0]."' /></div>";
                  $output .= "<div id='wmItMR'><img src='".$this->path."img/rename.gif' onclick=\"reguser('renamefile','".$path.$fileList[$i][0]."','file');\" class='naviLinks' title='Umbenennen ->".$fileList[$i][0]."' /></div>";
                  $output .= "<div id='wmItD'></div>";
                  $output .= "<div id='wmSize' title='Dateigr&ouml;sse'>".$this->format_size($fileList[$i][1])."</div>";
                  $output .= "<div id='wmRights' title='Dateirechte' onclick='reguser(\"chmod\",\"".$path."\",\"".$path.$fileList[$i][0]."\");' >|".$fileList[$i][2]."|</div>";
                  $output .= "<div id='wmDate' title='letztes &Auml;nderungsdatum'>".$fileList[$i][3]."</div>";
                  $output .= "<div id='wmItD'></div>";
                  $output .= "<div id='wmItMR'><img src='".$this->path."img/download.gif' onclick=\"window.location.href='".$this->path."source/lib.php?downloadFile=".$fileList[$i][0]."&real_vrz=".$path."'\" class='naviLinks' title='Download -> ".$fileList[$i][0]."' /></div>";
                  $output .= "<div id='wmClear'></div>";
                  $output .= "</div>";
                  echo $output;
                  // Gesamtgrsse aller Dateien im Vrz. ermitteln
                  $size += $fileList[$i][1];
              }

              if (count($fileList) > 0)  {
                  $output = "<div align='right' id='normLinks'><b>(Vrz/Dateien:".count($dirList)."/".count($fileList).")&nbsp;Gesamtgr&ouml;sse: ".$this->format_size($size)."</b></div>";
                  echo $output;
              }
    }



        // Funktion, liest die nicht anzuzeigenden Verzeichnisse in das bergabeArray ein
        // @ $arrayAusblenden - Array mit den auszublendenden Verzeichnissen
    static function secureNotShow_xml(&$arrayNotShow) {
        if ($xml = @simplexml_load_file("einstllg.xml"))  {
                $a = 0;
                foreach($xml->xpath('/ResultSet/Result/Ausblenden') as $node)  {
                    $arrayNotShow[$a] = $node;
                    $a++;
                }
                return true;
        }
        else  {
                return false;
        }
    }


        //#######################################################
    // liest nicht anzeigbare Verzeichnisse aus der XML Einstellungsdatei aus
    private function read_xml() {
        $xml = @simplexml_load_file("einstllg.xml");
        $attr = $xml->attributes();
        $this->rootDir = $attr["vrz"];
        $a = 0;
        foreach($xml->xpath('/ResultSet/Result/Ausblenden') as $node)  {
            $this->noPrintDir[$a] = $node;
            $a++;
        }
    }

    //#######################################################
    // gibt den Pfad des anzeigbaren Startordners vom Webmanager wieder
    public function get_rootDir()  {
                return $this->rootDir;
        }

    //#######################################################
    // Formatiert einen bergebenen String (##.###.### Byte)
    private function format_size($temp)  {
        $reverse = @strrev($temp);
        $array   = @str_split($reverse,3);
        $reverse = "";
        for($i=0;$i<count($array);$i++)  {
            if($i == count($array)-1)  {
                $reverse .= $array[$i];
            }
            else  {
                $reverse .= $array[$i].".";
            }
        }
        return @strrev($reverse)." Byte";
    }

    //#######################################################
    // Formatiert die oktale Darstellung der Dateirechte
    private function format_permission($temp)  {
        return @substr(@decoct($temp),-3);
    }

    //#######################################################
    // Formatiert die bergebene Zeitvariable (Tag.Monat.Jahr, Stunde:Minute)
    private function format_gettime($temp)  {
            return @date("d.m.Y, H:i",@filemtime($temp));
    }

    //#######################################################
    // blendet das relative Ursprungsverzeichnis aus
    public function print_dir() {
        return $this->absoluteDir;
    }

    //#######################################################
    // zeigt nur das aktuelle Verzeichnis ohne Pfad an
    private function formatDirlist($stringdata)  {
       $temp = explode("/",$stringdata);
       return $temp[count($temp)-1];
    }

    //#######################################################
    // setzt die Hintergrundfarbe der Balken bei den Verzeichnissen
    public function set_colors($col1="#EEEEEE",$col2="#DEDFDE") {
       $this->color1 = $col1;
       $this->color2 = $col2;
       return 0;
    }

    //#######################################################
    // Sicherheitsfunktion!
    // Schreibt die aktuellen Dateinamen und das aktuelle Verzeichnis zeilenweise
    // md5 verschlsselt in die temporre Datei: sec.tmp
    private function writeSecurityData() {
       if (count($this->filelist) > 0)  {
                    if ($this->directory != "")  {
                            $ip         = md5(getenv("REMOTE_ADDR"))."\n";
                            $time       = time()."\n";
                            $arrayFiles = array();
                            $vrz = md5($this->directory)."\n";
                            for ($i=0;$i<count($this->realdirlist);$i++)  {
                                    $temp1 = explode("/",$this->realdirlist[$i][0]);
                                    $temp2 = md5($temp1[count($temp1)-1]);
                                        array_push($arrayFiles,$temp2);
                                }

                            for($i=0;$i<count($this->filelist);$i++)  {
                                        array_push($arrayFiles,md5($this->filelist[$i][0]));
                                }
                            $temp = implode("\n",$arrayFiles);
                                $fp = fopen("sec.tmp","w");
                                fwrite($fp,$ip.$time.$vrz.$temp);
                                fclose($fp);
                                unset($temp,$temp1,$temp2,$vrz,$arrayFiles,$ip,$fp);
                        }
           }
       return 0;
    }

}

/*###########################################################
  - Erstellt ein Zip Archiv, Verzeichnisse und Dateien knnen
  - eingefgt werden
#############################################################*/
class createZip  {

    public $compressedData = array();
    public $centralDirectory = array();
    public $endOfCentralDirectory = "\x50\x4b\x05\x06\x00\x00\x00\x00";
    public $oldOffset = 0;

    public function getZipRessources($source,&$ressourceFilesArray,&$ressourceDirsArray)  {
        if (@file_exists($source))  {
            if (@is_dir($source))  {
                $handle = @opendir($source);
                while (false !== ($file = @readdir($handle)))  {
                    if ($file != '.' && $file != '..' && $file !='')  {
                                if (is_dir($source."/".$file))  {
                                        array_push($ressourceDirsArray,$source."/".$file."/");
                                }
                                if (is_file($source."/".$file))  {
                                        array_push($ressourceFilesArray,$source."/".$file);
                                }
                        $this->getZipRessources($source."/".$file,$ressourceFilesArray,$ressourceDirsArray);
                    }
                }
                @closedir($handle);
                return true;
            } else  {
                    return true;
            }
        }  else  {
           return false;
        }
    }

    public function addDirectory($directoryName) {
        $directoryName = str_replace("\\", "/", $directoryName);

        $feedArrayRow = "\x50\x4b\x03\x04";
        $feedArrayRow .= "\x0a\x00";
        $feedArrayRow .= "\x00\x00";
        $feedArrayRow .= "\x00\x00";
        $feedArrayRow .= "\x00\x00\x00\x00";

        $feedArrayRow .= pack("V",0);
        $feedArrayRow .= pack("V",0);
        $feedArrayRow .= pack("V",0);
        $feedArrayRow .= pack("v", strlen($directoryName) );
        $feedArrayRow .= pack("v", 0 );
        $feedArrayRow .= $directoryName;

        $feedArrayRow .= pack("V",0);
        $feedArrayRow .= pack("V",0);
        $feedArrayRow .= pack("V",0);

        $this -> compressedData[] = $feedArrayRow;

        $newOffset = strlen(implode("", $this->compressedData));

        $addCentralRecord = "\x50\x4b\x01\x02";
        $addCentralRecord .="\x00\x00";
        $addCentralRecord .="\x0a\x00";
        $addCentralRecord .="\x00\x00";
        $addCentralRecord .="\x00\x00";
        $addCentralRecord .="\x00\x00\x00\x00";
        $addCentralRecord .= pack("V",0);
        $addCentralRecord .= pack("V",0);
        $addCentralRecord .= pack("V",0);
        $addCentralRecord .= pack("v", strlen($directoryName) );
        $addCentralRecord .= pack("v", 0 );
        $addCentralRecord .= pack("v", 0 );
        $addCentralRecord .= pack("v", 0 );
        $addCentralRecord .= pack("v", 0 );
        $ext = "\x00\x00\x10\x00";
        $ext = "\xff\xff\xff\xff";
        $addCentralRecord .= pack("V", 16 );

        $addCentralRecord .= pack("V", $this -> oldOffset );
        $this -> oldOffset = $newOffset;

        $addCentralRecord .= $directoryName;

        $this -> centralDirectory[] = $addCentralRecord;
    }

    public function addFile($data, $directoryName)   {

        $directoryName = str_replace("\\", "/", $directoryName);

        $feedArrayRow = "\x50\x4b\x03\x04";
        $feedArrayRow .= "\x14\x00";
        $feedArrayRow .= "\x00\x00";
        $feedArrayRow .= "\x08\x00";
        $feedArrayRow .= "\x00\x00\x00\x00";

        $uncompressedLength = strlen($data);
        $compression = crc32($data);
        $gzCompressedData = gzcompress($data);
        $gzCompressedData = substr( substr($gzCompressedData, 0, strlen($gzCompressedData) - 4), 2);
        $compressedLength = strlen($gzCompressedData);
        $feedArrayRow .= pack("V",$compression);
        $feedArrayRow .= pack("V",$compressedLength);
        $feedArrayRow .= pack("V",$uncompressedLength);
        $feedArrayRow .= pack("v", strlen($directoryName) );
        $feedArrayRow .= pack("v", 0 );
        $feedArrayRow .= $directoryName;

        $feedArrayRow .= $gzCompressedData;

        $feedArrayRow .= pack("V",$compression);
        $feedArrayRow .= pack("V",$compressedLength);
        $feedArrayRow .= pack("V",$uncompressedLength);

        $this -> compressedData[] = $feedArrayRow;

        $newOffset = strlen(implode("", $this->compressedData));

        $addCentralRecord = "\x50\x4b\x01\x02";
        $addCentralRecord .="\x00\x00";
        $addCentralRecord .="\x14\x00";
        $addCentralRecord .="\x00\x00";
        $addCentralRecord .="\x08\x00";
        $addCentralRecord .="\x00\x00\x00\x00";
        $addCentralRecord .= pack("V",$compression);
        $addCentralRecord .= pack("V",$compressedLength);
        $addCentralRecord .= pack("V",$uncompressedLength);
        $addCentralRecord .= pack("v", strlen($directoryName) );
        $addCentralRecord .= pack("v", 0 );
        $addCentralRecord .= pack("v", 0 );
        $addCentralRecord .= pack("v", 0 );
        $addCentralRecord .= pack("v", 0 );
        $addCentralRecord .= pack("V", 32 );

        $addCentralRecord .= pack("V", $this -> oldOffset );
        $this -> oldOffset = $newOffset;

        $addCentralRecord .= $directoryName;

        $this -> centralDirectory[] = $addCentralRecord;
    }

    /**
     * Fucntion to return the zip file
     *
     * @return zipfile (archive)
     */

    public function getZippedfile() {

        $data = implode("", $this -> compressedData);
        $controlDirectory = implode("", $this -> centralDirectory);

        return
            $data.
            $controlDirectory.
            $this -> endOfCentralDirectory.
            pack("v", sizeof($this -> centralDirectory)).
            pack("v", sizeof($this -> centralDirectory)).
            pack("V", strlen($controlDirectory)).
            pack("V", strlen($data)).
            "\x00\x00";
    }

        public function forceDownload($archiveName) {
                $headerInfo = '';

                if(ini_get('zlib.output_compression')) {
                        ini_set('zlib.output_compression', 'Off');
                }

                header("Pragma: public");
                header("Expires: 0");
                header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
                header("Cache-Control: private",false);
                header("Content-Type: application/zip");
                header("Content-Disposition: attachment; filename=".basename($archiveName).";" );
                header("Content-Transfer-Encoding: binary");
                header("Content-Length: ".filesize($archiveName));
                readfile("$archiveName");

         }
}


/*###########################################################
  - liest und schreibt den Dateiinhalt der orginalen Daten
#############################################################*/
class Fileobject  {

    private $file;
    private $filestring;
    private $content;

    //#######################################################
    // Konstruktor Dateiname -> interne Variable
    // Inhalt des zu schreibenden Contents -> interne Variable
    public function __construct($temp1,$temp2)  {
             $this->file    = $temp1;
             $this->content = $temp2;
    }

    //#######################################################
    // Destruktor lscht alle internen Variablen
    public function __destruct()  {
            unset($this->filestring,$this->file,$this->content);
    }

    //#######################################################
    // gibt Dateiinhalt aus
    public function print_file()  {
           $temp = @file_get_contents($this->file);
           $temp = @str_replace("</textarea>","&lt;/textarea&gt;",$temp);
           header("Content-Type: text/html; charset=ISO-8859-1");
           echo $temp;
    }

    //#######################################################
    // schreibt den Dateiinhalt neu
    public function write_file()  {
        $temp1 = $this->decode_content($this->content);
        $fp = @fopen($this->file,"wb");
        @fwrite($fp,$temp1);
        @fclose($fp);
    }

    //#######################################################
    // decodiert den von JS bergebenen Dateiinhalt anhand der ASCII Zeichen
    private function decode_content(&$temp1)  {
                $array = array();
                $array = explode("-",$temp1);
                $temp1 = "";
                for($i=1;$i<count($array);$i++)  {
                        $temp1 .= chr($array[$i]);
                }
                return $temp1;
        }
}

class Protection_class
{
    private $rootDir          = "";              // Rootverzeichnis des Webmanagers
    private $xmlUserArray     = array(array());  // User XML Daten 2D- Array
                                                                                             // [$i][0] -> md5(ip)
                                                                                             // [$i][1] -> timestamp
                                                                                             // [$i][2] -> md5(letzte Verzeichnisse)
                                                                                             // [$i][3] -> md5(aktuelle Verzeichnisse)
                                                                                             // [$i][4] -> md5(aktuelle Dateien)
    private $flagXmlUserArray = array();         // Array, welche Userdaten werden bearbeitet?
                                                                                                 // 0 -> User lschen
                                                                                                 // 1 -> User unverndert bernehmen
                                                                                                 // 2 -> User mit neuem timestamp updaten
    static private $instance  = false;
    private function __construct(){}

    static function instance()  {
        if(!Protection_class::$instance)  {
            Protection_class::$instance = new Protection_class();
        }
        return Protection_class::$instance;
    }

    private function read_xml() {
        $xml = @simplexml_load_file("sec.xml");
        $attr = $xml->attributes();
        $this->rootDir = $attr["vrz"];
        $a = 0;
        foreach($xml->xpath('/ResultSet/Result/Ausblenden') as $node)  {
            $this->noPrintDir[$a] = $node;
            $a++;
        }
    }



        // Anmeldeformular fr den User des Webmanagers
        static public function signIn()  {
                $output  = "<form method=\"post\" enctype=\"text/plain\" style=\"border: 1px solid black;padding:5px;margin:0 auto;\" name=\"wm_fomrsignIn\" id=\"wm_fomrsignIn\">";
                $output .= "<span id=\"normText\">Benutzer:<br/ ></span>";
                $output .= "<input type=\"text\" style=\"border:1px solid black;width:160px;\" name=\"wm_benutzername\" id=\"wm_benutzername\" /><br/ >";
                $output .= "<span id=\"normText\">Passwort:<br/ ></span>";
                $output .= "<input type=\"password\" style=\"border:1px solid black;width:160px;\" name=\"wm_benutzerpwd\" id=\"wm_benutzerpwd\" /><br /><br />";
                $output .= "<input type=\"button\" value=\"Anmelden\" class=\"buttons\" name=\"wm_benutzerSubmit\" id=\"wm_benutzerSubmit\" onclick=\"reguser('','','');\" />&nbsp;&nbsp;&nbsp;";
                $output .= "<input type=\"reset\" value=\"Abbruch\" class=\"buttons\" name=\"wm_benutzerSubmit\" id=\"wm_benutzerSubmit\" />&nbsp;&nbsp;&nbsp;";
                $output .= "</form>";
                $output .= "<!-- Verzeichnisausgabe ";
                return $output;
        }



        // lese XML-User Daten in ein 2D KlassenvariablenArray ein
        // Rckgabe Anzahl der eingetragenen User
        private function read_sec_xml($file = "sec.xml")  {
        if (file_exists($file)) {
            $xml = simplexml_load_file($file);
            $i = 0;
                while (isset($xml->root->user[$i]))  {
                $this->xmlUserArray[$i][0] = $xml->root->user[$i]->fingerprint;
                $this->xmlUserArray[$i][1] = $xml->root->user[$i]->time;
                $this->xmlUserArray[$i][2] = $xml->root->user[$i]->viewDirs;
                $this->xmlUserArray[$i][3] = $xml->root->user[$i]->viewFiles;
                $this->xmlUserArray[$i][4] = $xml->root->user[$i]->dir;
                $i++;
                }
                return $i;
        }
            else  {
            return -1;
        }
    }

    //#######################################################
    // liest das eingestellte Timeout der User aus der XML Einstellungsdatei aus
    private function read_xml_timeout($file = "einstllg.xml")  {
        $xml = simplexml_load_file("einstllg.xml");
        $attr = $xml->attributes();
        return $attr["logout"];
    }

    //#######################################################
    // Main Funktion, ruft alle Einstellungsdateien auf
    public function mainSecurity($action,$dataObjekt,$flag)  {
    //        $countUser   = $this->read_sec_xml();                         // Anzahl der eingetragenen User
                $lastTime    = $this->read_xml_timeout();        // Timeout der Aktionen -> einstllg.xml
                $timestamp   = time();                           // aktueller Timestamp ermitteln
                $ipdata      = md5(getenv("REMOTE_ADDR"));       // akt. IP verschlsseln
                $fileObjekt  = md5(basename($dataObjekt));       // akt. Datei/Vrz. ohne Pfad verschlsseln
                $pathObject  = dirname($dataObjekt)."/";                // akt. Pfad ohne Datei/Vrz. ermitteln
                $sessionPath = "./temp";

                // wenn Log Verzeichnis nicht existiert, lege es an
                // lege die index.htm im Verzeichnis an, als Schutz gegen unerlaubtes Listing
                // lege erste LogDatei mit der verschlsselten IP Adresse als Namen an, speichere akt. Vrz.
        if (file_exists($sessionPath))  {
                if (is_dir($sessionPath))  {
                                if ($dh = opendir($sessionPath)) {
                                       $allSessionFiles = array();                // Array welches die User Files enthlt
                                       $i = 0;
                                   while (($file = @readdir($dh)) !== false)  {
                                           if ($file <> "index.htm") {
                                                   $allSessionFiles[$i] = $file;
                                                   $i++;
                                           }
                                   }
                       }

                                // Datei/ Vrz. Aktionen legitimieren, hierfr muss ein Sessionfile existieren
                                // mit der eingestellten Berechtigungszeit, das angeforderte Verzeichnis wird
                                // analysiert
                        if ($action == "readAction")  {
                                $flag = 0;
                                        for ($i; $i < count($allSessionFiles);$i++)  {
                                                if($ipdata.".sec" == $allSessionFiles[$i])  {
                                                        $filetime = fileatime($allSessionFiles[$i]);
                                                        if ($timestamp - $lastTime <= $filetime)  {
                                                                // User gefunden und innerhalb der Logzeit
                                                                // weitere Verarbeitung
                                                                $lastPath = file_get_contents($allSessionFiles[$i]);

                                                                if ($pathObject == $lastPath)  {
                                                                        $flag = 1;
                                                                        return true;
                                                                }
                                                        }
                                                        // Logzeit abgelaufen
                                                        else { return false; }
                                                }
                                        }
                                        // File/ User wurde nicht gefunden, keine Aktion erlaubt!
                                        if ($flag != 1)  {
                                                return false;
                                        }
                        }

                }
                else  {
                        @mkdir("temp",0755);
                        $handle = @fopen ("index.htm", "wb");
                            @chmod ($fileName, 0644);
                        @fclose($handle);
                        $handle = @fopen ($ipdata.".sec", "wb");
                        fwrite($handle,$dataObjekt);
                            @chmod ($fileName, 0644);
                        @fclose($handle);
                }
        }
        else  {
                @mkdir("temp",0755);
                $handle = @fopen ("index.htm", "wb");
                    @chmod ($fileName, 0644);
                @fclose($handle);
                $handle = @fopen ($ipdata.".sec", "wb");
                fwrite($handle,$dataObjekt);
                    @chmod ($fileName, 0644);
                @fclose($handle);
        }
        }

    //#######################################################
    // DebugFunktion, xmlUserArray[][] Array richtig zurgewiesen? - Debug OK!
    public function debugWriteUserData()  {
                $count = $this->read_sec_xml() + 1;
                if($count > 0)  {
                    $temp = "";
                    for ($i=0; $i < count ($count); $i++)  {
                            for ($a=0; $a<5; $a++)  {
                                    $temp .= $this->xmlUserArray[$i][$a]."|";
                            }
                            $temp .= "\n";
                    }
                    file_put_contents("dummy.txt",$temp);
                }
        }

    //#######################################################
    // liest das eingestellte Rootverzeichnis aus der XML Einstellungsdatei aus
    static function read_xml_rootvrz() {
        $xml = @simplexml_load_file("einstllg.xml");
        $attr = $xml->attributes();
        return $attr["vrz"];
    }


    //#######################################################
    // prft ob angebene Datei im aktuellen Verzeichnis vorhanden ist und angezeigt wurde
    static function checkSecFile($vrz,$file)  {
            $zeilen = array();
            $vrz    = md5($vrz);
            if ($file != "")  {
               $file   = md5(basename($file));
            }
            $ip     = md5(getenv("REMOTE_ADDR"));
            $time   = time();
            $zeilen = file("sec.tmp");

            // ist die IP des Anzeigers eine andere welche die Aktion anfordert -> false
            if (trim($zeilen[0]) != $ip)
            { return false; }
            // ist seit der letzten Anzeige mehr als eine Stunde vergangen -> false
            // $timeout = $this->read_xml_timeout();
            if (trim($zeilen[1]) - $time > 3600)
            { return false; }
            // ist das angeforderte Verzeichnis fr die Aktion nicht das Angezeigte (erlaubte) -> false
            if (trim($zeilen[2]) != $vrz)
            { return false; }
            if ($file != "")  {
                    // ist die angeforderte Datei im aktuellen Verzeichnis, wenn ja -> true
                for ($i=3; $i<count($zeilen); $i++)  {
                            if (trim($zeilen[$i]) == $file)  {
                                    return true;
                                    break;
                            }
                    }
            return false;
        }
        return true;
    }


    //#######################################################
    // sucht und ersetzt die POST Variablen auf unerlaubte Befehle
        static function scanvar()  {

        }

}

class Manipulate
{
    //#######################################################
    // erstellt eine Datei im angegebenen Verzeichnis
    static function boolCreateFile($fileName)  {
        $handle = @fopen ($fileName, "wb");
        @chmod ($fileName, 0644);
        @fclose($handle);
    }

    //#######################################################
    // erstellt eine Datei im angegebenen Verzeichnis
    static function boolCreateDir($dirName)  {
        @mkdir($dirName,0777);
    }

    //#######################################################
    // benennt eine Datei bzw. ein Verzeichnis um
    static function renameObject($oldObjectName,$newObjectName)  {
        @rename($oldObjectName,$newObjectName);
    }

    //#######################################################
    // lscht ein Verzeichnis und deren Verzeichnisinhalt rekursiv im aktuellen Verzeichnis
    static function boolDelDir($source)  {
        if(@file_exists($source))  {
            if(@is_dir($source))  {
                $handle=@opendir($source);
                while (false !== ($file = @readdir($handle)))  {
                    if($file != '.' && $file != '..' && $file !='')  {
                        Manipulate::boolDelDir($source."/".$file);
                    }
                }
                @closedir($handle);
                return @rmdir($source."/".$file);
            } else  {
                return @unlink($source);
            }
        }  else  {
           return false;
        }
    }

    //#######################################################
    // lscht die angegebene Datei
    static function boolDelFile($filename)  {
        @unlink($filename);
    }

    //#######################################################
    // Upload von den Dateien - debug: OK
    static function boolUploadFiles($vrz)  {
            for( $i=0 ; $i<10 ; $i++ )
            {
                    if (!isset($_FILES["file_".$i]["name"]))
                    {  break;  }
                move_uploaded_file($_FILES["file_".$i]["tmp_name"],$vrz.$_FILES["file_".$i]["name"]);
            }
    }
}




// #############################################################################################



if(isset($_POST["param_action"]) && isset($_POST["wm_input_pwd"]) && isset($_POST["wm_param"]))  {

    switch($_POST["param_action"])  {
        case "infodaten":
            Browser::ArrayReadDir($_POST["wm_param"],$dirList,$fileList);
            $temp = new Browser();
            $temp->formatItemList($_POST["wm_param"],$dirList,$fileList);
            $replaceArray = array("../","./");
            $printDir = str_replace($replaceArray,"",$_POST["wm_param"]);
            echo "<!-- Verzeichnisausgabe ".$printDir;
            unset($temp);
            break;

        case "voidReloadSite":
            //#######################################################
            // erstellt ein Objekt Browser Objekt mit den bergebenen Parametern
            // welches das aktuelle Verzeichnis darstellt
            if (isset($_POST["wm_param"])&&$_POST["wm_param"]<>"")  {
                Browser::ArrayReadDir($_POST["wm_param"],$dirList,$fileList);
                $temp = new Browser();
                $temp->formatItemList($_POST["wm_param"],$dirList,$fileList);
                $replaceArray = array("../","./");
                $printDir = str_replace($replaceArray,"",$_POST["wm_param"]);
                echo "<!-- Verzeichnisausgabe ".$printDir;
            }
            break;

        case "CreateFile":
            //#######################################################
            // ruft die Funktion boolCreateFile aus der Klasse Manipulate auf
            // welche eine leere Datei erstellt, dann Verzeichnis neu einlesen
            if (isset($_POST["wm_param"])&&$_POST["wm_param"]<>"")  {
                Manipulate::boolCreateFile($_POST["wm_param"]);
            }
            break;

        case "CreateDir":
            //#######################################################
            // ruft die Funktion boolCreateDir aus der Klasse Manipulate auf
            // welche neues Verzeichnis erstellt, dann Verzeichnis neu einlesen
            if (isset($_POST["wm_param"])&&$_POST["wm_param"]<>"")  {
                Manipulate::boolCreateDir($_POST["wm_param"]);
            }
            break;

        case "DeleteFile":
            //#######################################################
            // ruft die Funktion boolDelFile aus der Klasse Manipulate auf
            // welche eine Datei lscht, dann Verzeichnis neu einlesen
            if (isset($_POST["wm_param"])&&$_POST["wm_param"]<>"")  {
                Manipulate::boolDelFile($_POST["wm_param"]);
            }
            break;

        case "DeleteDir":
            //#######################################################
            // ruft die Funktion boolDelFile aus der Klasse Manipulate auf
            // welche ein Verzeichnis rekursiv lscht, dann Verzeichnis neu einlesen
            if (isset($_POST["wm_param"])&&$_POST["wm_param"]<>"")  {
                Manipulate::boolDelDir($_POST["wm_param"]);
            }
            break;

        case "renamefile":
            //#######################################################
            // ruft die Funktion renameObject aus der Klasse Manipulate auf
            // welche eine Datei oder Verzeichnis umbenennt
            if (($_POST["wm_param"]<>"")&&($_POST["wm_param2"]<>""))  {
                Manipulate::renameObject($_POST["wm_param"],$_POST["wm_param2"]);
            }
            break;

        case "infofile":
             //#######################################################
             // erstellt ein Objekt fileobject das den Dateiinhalt anzeigt
             if (isset($_POST["wm_param"])&&$_POST["wm_param"]<>"")  {
                 $list = new Fileobject($_POST["wm_param"],$_POST["wm_param2"]);
                 if (isset($_POST["wm_param2"]))  {
                     $list->write_file();
                 }
                 $list->print_file();
             }
             break;

        case "createZip":
             //#######################################################
             // erstellt ein zipArchiv vom angegebenen Verzeichnis und
             // speichert dieses im aktuellen Verzeichnis als Datei ab
             if (isset($_POST["wm_param"]) && $_POST["wm_param"]!= "")  {
                 if (isset($_POST["wm_param2"]) && $_POST["wm_param2"]!="")  {
                     $ressourceFilesArray = array();
                     $ressourceDirsArray  = array();
                     $replaceArray = array("../","./");
                     $createZip = new createZip;
                     $createZip ->getZipRessources($_POST["wm_param"],$ressourceFilesArray,$ressourceDirsArray);
                     // archiviere alle Verzeichnisse und Unterverzeichnisse
                     for ($i=0;$i<count($ressourceDirsArray);$i++)  {
                          $ressourceDirsArray[$i] = str_replace($replaceArray,"",$ressourceDirsArray[$i]);
                          $createZip->addDirectory($ressourceDirsArray[$i]);
                     }
                     // archiviere alle Dateien in den enthaltenen Unterverzeichnissen
                     for ($i=0;$i<count($ressourceFilesArray);$i++)  {
                          $fileContents = file_get_contents($ressourceFilesArray[$i]);
                          $ressourceFilesArray[$i] = str_replace($replaceArray,"",$ressourceFilesArray[$i]);
                          $createZip -> addFile($fileContents, $ressourceFilesArray[$i]);
                     }
                     $fileName = $_POST["wm_param2"];
                     $fd  = fopen ($fileName, "wb");
                     fwrite ($fd, $createZip -> getZippedfile());
                     fclose ($fd);
                     // Download des zip Files
                     // $createZip->forceDownload($fileName);
                     echo "OK";
                 }
             }
             break;

        case "uploadFiles":
            //#######################################################
            // ruft UploadFunktion fr die bergebenen Dateien auf
            if (isset($_FILES["file_0"]["name"]))  {
                Manipulate::boolUploadFiles($_POST["wm_param"]);
            }
            file_put_contents("temp.txt",$_POST["wm_param"]);
            break;

        case "downloadFile":
            //#######################################################
            // Download einer erlaubten Datei im aktuellen Verzeichnis
            $file = $_POST["wm_param"];
            $arrayfile = explode("/",$temp);
            $file = $arrayfile[count($arrayfile)-1];
            $arrayfile[count($arrayfile)-1] = "";
            $vrz  = implode("/",$arrayfile);

            $temp1 = $_GET["real_vrz"];
            $temp2 = $_GET["downloadFile"];
            header("Content-Type: x-type/x-subtype");
            header("Content-Disposition: attachment; filename=\"$temp2\"");
            readfile($temp1.$temp2);
            break;

        case "chmod":
            //#######################################################
            // ndern der Dateirechte der angegebenen Datei
            $zahl = $_POST["wm_param2"];
            if (@strlen($zahl) == 3)  {
                $oktZahl = octdec($zahl);
                @chmod ($_POST["wm_param"], $oktZahl);
                @clearstatcache();
            }
            break;

        default:
            echo Protection_class::signIn();
    }

}


// Downloadfunktion fr vorhandene Dateien im aktuellen Verzeichnis
if (isset($_GET["downloadFile"]) && isset($_GET["real_vrz"]))  {
    $temp1 = $_GET["real_vrz"];
    $temp2 = $_GET["downloadFile"];
    header("Content-Type: x-type/x-subtype");
    header("Content-Disposition: attachment; filename=\"$temp2\"");
    readfile($temp1.$temp2);
}

// ruft UploadFunktion fr die bergebenen Dateien auf
if (isset($_FILES["file_0"]["name"]))  {
    Manipulate::boolUploadFiles($_POST["wm_param"]);
}


// $fp = fopen("testing.txt","a");
// fwrite($fp,memory_get_usage()."\n");
// fclose($fp);

/**
 *   $singleton = Protection_class::instance();
 *   if ($singleton->mainSecurity("readAction",$data = "./../joomla",$flag = "") )
 *   {  echo "VORHANDEN! ".$data."<br><br>";  }


 *   if ($singleton->mainSecurity("readAction",$data = "./../.htaccess",$flag = "") )
 *   {  echo "VORHANDEN! ".$data;  }
 */





// - Webmanager copyright Dirk W. 2008 - 2015 http://flupdiwup.de
// - Der Autor schliesst jeglichen Haftungsanspruch durch die Benutzung dieses Managers aus!
// - Diese Version darf frei benutzt werden, solange keine nderungen am Javascript bzw. PHP Code vorgenommen werden
// - nderungen an den Scripten sind ausschliesslich mit Absprache des Autors legitim
// - Dieser Copyright- Verweis muss in allen enthaltenen Dateien erhalten bleiben!
// - Ein Anspruch auf Support besteht nicht
// - Dieser Manager darf ausschliesslich unter der Autorenhomepage bezogen werden, Verlage und Downloadarchive wenden sich bitte fr weitergehende Rechte der Verbreitung an den Autor
// - Ein Feedback ist erwnscht und kann unter der Autorenhomepage gegeben werden